diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index 8bcc73ce..1428ef41 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -11,16 +11,18 @@ import uuid
 import asyncio
 import re
 import datetime
-from typing import Optional, Dict, Any
+import base64
+from typing import Optional, Dict, Any, List
 
-from modules.datamodels.datamodelChat import ChatWorkflow, UserInputRequest, ChatMessage, WorkflowModeEnum
+from modules.datamodels.datamodelChat import ChatWorkflow, UserInputRequest, ChatDocument, WorkflowModeEnum
 from modules.datamodels.datamodelUam import User
 from modules.datamodels.datamodelAi import AiCallRequest, AiCallOptions, OperationTypeEnum, ProcessingModeEnum
 from modules.shared.timeUtils import getUtcTimestamp, parseTimestamp
 from modules.services import getInterface as getServices
 from modules.connectors.connectorPreprocessor import PreprocessorConnector
 from modules.features.chatbot.eventManager import get_event_manager
-from modules.features.chatbot.eventManager import get_event_manager
+from modules.datamodels.datamodelDocref import DocumentReferenceList, DocumentItemReference
+from modules.workflows.methods.methodAi.methodAi import MethodAi
 
 logger = logging.getLogger(__name__)
 
@@ -52,107 +54,6 @@ def _extractJsonFromResponse(content: str) -> Optional[dict]:
     return None
 
 
-async def _generateSqlFromQuestion(services, userQuestion: str, context: str = "") -> str:
-    """Generate SQL query directly from user question when JSON parsing fails."""
-    current_date = datetime.datetime.now().strftime("%d.%m.%Y")
-    sqlPrompt = f"""Heute ist der {current_date}.
-
-Du bist ein Chatbot der Althaus AG.
-Du hast Zugriff auf ein SQL query tool, dass es dir ermöglicht, SQL SELECT Abfragen auf der Althaus AG Datenbank auszuführen.
-
-DATENBANK-INFORMATIONEN:
-- Datenbankdatei: /data/database.db (SQLite)
-- Tabellen: Artikel, Einkaufspreis, Lagerplatz_Artikel
-
-Die Datenbank besteht aus drei Tabellen, die über Beziehungen verbunden sind:
-- **Artikel**: Enthält alle Produktinformationen (I_ID, Artikelbezeichnung, Artikelnummer, etc.)
-- **Einkaufspreis**: Enthält Preisdaten (m_Artikel, EP_CHF)
-- **Lagerplatz_Artikel**: Enthält Lagerbestands- und Lagerplatzinformationen (R_ARTIKEL, R_LAGERPLATZ, S_IST_BESTAND, etc.)
-- **Beziehungen**: 
-  - Artikel.I_ID = Einkaufspreis.m_Artikel
-  - Artikel.I_ID = Lagerplatz_Artikel.R_ARTIKEL
-
-TABELLEN-SCHEMA (WICHTIG - Spalten mit Leerzeichen/Sonderzeichen IMMER in doppelte Anführungszeichen setzen):
-
-Tabelle 1: Artikel
-CREATE TABLE Artikel (
-  "I_ID" INTEGER PRIMARY KEY,
-  "Artikelbeschrieb" TEXT,
-  "Artikelbezeichnung" TEXT,
-  "Artikelgruppe" TEXT,
-  "Artikelkategorie" TEXT,
-  "Artikelkürzel" TEXT,
-  "Artikelnummer" TEXT,
-  "Einheit" TEXT,
-  "Gesperrt" TEXT,
-  "Keywords" TEXT,
-  "Lieferant" TEXT,
-  "Warengruppe" TEXT
-)
-
-Tabelle 2: Einkaufspreis
-CREATE TABLE Einkaufspreis (
-  "m_Artikel" INTEGER,
-  "EP_CHF" FLOAT
-)
-
-Tabelle 3: Lagerplatz_Artikel
-CREATE TABLE Lagerplatz_Artikel (
-  "R_ARTIKEL" INTEGER,
-  "R_LAGERPLATZ" TEXT,
-  "S_BESTELLTER_BESTAND" INTEGER,
-  "S_IST_BESTAND" TEXT,
-  "S_MAXIMALBESTAND" INTEGER,
-  "S_MINDESTBESTAND" INTEGER,
-  "S_RESERVIERTER_BESTAND" INTEGER,
-  "S_SOLL_BESTAND" INTEGER
-)
-
-SQL-HINWEISE:
-- Verwende IMMER doppelte Anführungszeichen für Spaltennamen: "Artikelkürzel", "Artikelnummer", etc.
-- Für Textsuche verwende LIKE mit Wildcards: WHERE a."Artikelbezeichnung" LIKE '%suchbegriff%'
-- Für Preisabfragen: Nutze JOINs um auf e."EP_CHF" zuzugreifen
-- Für Lagerbestände: Nutze JOINs um auf l."S_IST_BESTAND", l."S_SOLL_BESTAND", etc. zuzugreifen
-- WICHTIG bei S_IST_BESTAND: Dieser Wert kann "Unbekannt" sein (TEXT), nicht nur Zahlen! Prüfe mit WHERE l."S_IST_BESTAND" != 'Unbekannt' wenn du nur numerische Werte willst
-- Verwende Tabellenaliase (a für Artikel, e für Einkaufspreis, l für Lagerplatz_Artikel) für bessere Lesbarkeit
-
-SQL-AGGREGATIONEN:
-Du kannst SQL-Aggregationsfunktionen verwenden, um statistische Auswertungen und Zusammenfassungen zu erstellen:
-- COUNT() - Anzahl zählen
-- SUM() - Summe berechnen (z.B. SUM(CASE WHEN l."S_IST_BESTAND" != 'Unbekannt' THEN CAST(l."S_IST_BESTAND" AS INTEGER) ELSE 0 END))
-- AVG() - Durchschnitt
-- MIN() / MAX() - Minimum/Maximum
-- GROUP BY - Gruppierung
-
-Beispiel für Lagerbestand-Aggregation:
-SELECT SUM(CASE WHEN l."S_IST_BESTAND" != 'Unbekannt' THEN CAST(l."S_IST_BESTAND" AS INTEGER) ELSE 0 END) as "Gesamtbestand"
-FROM Artikel a
-LEFT JOIN Lagerplatz_Artikel l ON a."I_ID" = l."R_ARTIKEL"
-WHERE a."Artikelbezeichnung" LIKE '%LED%'
-
-Generate a SQL SELECT query to answer this question: {userQuestion}{context}
-
-Return ONLY the SQL query, nothing else. Use SELECT queries only. Use double quotes for all column names."""
-    
-    sqlRequest = AiCallRequest(
-        prompt=sqlPrompt,
-        options=AiCallOptions(
-            resultFormat="txt",
-            operationType=OperationTypeEnum.DATA_ANALYSE,
-            processingMode=ProcessingModeEnum.BASIC
-        )
-    )
-    
-    sqlResponse = await services.ai.callAi(sqlRequest)
-    # Extract SQL from response (might be wrapped in markdown)
-    sql = sqlResponse.content.strip()
-    # Remove markdown code blocks if present
-    if sql.startswith("```"):
-        sql = re.sub(r'^```(?:sql)?\s*', '', sql)
-        sql = re.sub(r'\s*```$', '', sql)
-    return sql.strip()
-
-
 async def _generate_conversation_name(
     services,
     userPrompt: str,
@@ -170,39 +71,18 @@ async def _generate_conversation_name(
         Short conversation name (max 60 characters)
     """
     try:
-        # Truncate prompt if too long to avoid excessive token usage
         truncated_prompt = userPrompt[:200] if len(userPrompt) > 200 else userPrompt
         
-        # Create a prompt that detects the input language and generates title in the same language
-        name_prompt = f"""You are an expert in professional business communication. Your task is to create a professional conversation title.
+        name_prompt = f"""Create a professional conversation title in THE SAME LANGUAGE as the user's question.
 
-CRITICAL: The title MUST be in the SAME LANGUAGE as the user's question. If the question is in German, respond in German. If in French, respond in French. If in English, respond in English.
+Question: "{truncated_prompt}"
 
-USER QUESTION: "{truncated_prompt}"
-
-TASK:
-1. Identify the language of the user's question
-2. Identify the main topic of the question
-3. Create an elegant, professional title in THE SAME LANGUAGE as the question (max 60 characters, no punctuation)
-
-RULES:
-- Title MUST match the language of the input question exactly
-- DO NOT translate to another language
-- DO NOT just copy words from the question
-- Use professional language appropriate to the detected language
-- No punctuation (?, !, .)
-
-EXAMPLES:
-- Input (German): "wie viele leds haben wir auf lager?" → Title (German): "LED Lagerbestand"
-- Input (German): "wie viel kosten die leds ungefähr? was ist die preisrange?" → Title (German): "LED Preisübersicht"
-- Input (French): "combien de leds avons-nous en stock?" → Title (French): "Stock de LED"
-- Input (French): "combien coûtent les leds environ?" → Title (French): "Aperçu des Prix LED"
-- Input (English): "how many leds do we have in stock?" → Title (English): "LED Inventory Inquiry"
-- Input (English): "how much do the leds cost approximately?" → Title (English): "LED Price Overview"
-
-Respond ONLY with the title in the same language as the question, nothing else:"""
+Rules:
+- Title MUST be in the same language as the question (German→German, French→French, English→English)
+- Max 60 characters, no punctuation (?, !, .)
+- Professional and concise
+- Respond ONLY with the title, nothing else"""
         
-        # Ensure AI services are initialized before calling
         await services.ai.ensureAiObjectsInitialized()
         
         nameRequest = AiCallRequest(
@@ -211,131 +91,32 @@ Respond ONLY with the title in the same language as the question, nothing else:"
                 resultFormat="txt",
                 operationType=OperationTypeEnum.DATA_GENERATE,
                 processingMode=ProcessingModeEnum.DETAILED,
-                temperature=0.7  # Balanced temperature for creativity and consistency
+                temperature=0.7
             )
         )
         
         nameResponse = await services.ai.callAi(nameRequest)
-        raw_response = nameResponse.content.strip()
+        generated_name = nameResponse.content.strip()
         
-        logger.info(f"AI name generation raw response (full): {raw_response}")
-        
-        # Extract title from response - look for "TITEL:" or "TITLE:" marker first
-        generated_name = raw_response
-        
-        # Try to extract title after "TITEL:" or "TITLE:" marker (case insensitive)
-        title_markers = ["TITEL:", "TITLE:", "Titre:", "Titel:", "TITRE:", "titel:", "title:"]
-        for marker in title_markers:
-            if marker.lower() in raw_response.lower():
-                # Find the marker (case insensitive)
-                marker_pos = raw_response.lower().find(marker.lower())
-                if marker_pos >= 0:
-                    generated_name = raw_response[marker_pos + len(marker):].strip()
-                    # Take only the first line after the marker
-                    generated_name = generated_name.split('\n')[0].strip()
-                    logger.info(f"Extracted title after marker '{marker}': {generated_name}")
-                    break
-        
-        # If no marker found, try to find the last meaningful line
-        if generated_name == raw_response or len(generated_name) > 60:
-            lines = [line.strip() for line in raw_response.split("\n") if line.strip()]
-            # Look for a line that looks like a title (not too long, no colons except at start)
-            for line in reversed(lines):
-                # Skip lines that are clearly explanations or steps
-                if any(skip in line.lower() for skip in ["schritt", "step", "étape", "beispiel", "example", "wichtig", "important"]):
-                    continue
-                # Take lines that are reasonable title length and don't have colons in the middle
-                if 3 <= len(line) <= 60 and (":" not in line or line.startswith(":")):
-                    generated_name = line
-                    logger.info(f"Extracted title from last meaningful line: {generated_name}")
-                    break
-        
-        # Remove common prefixes/suffixes and clean up
-        generated_name = re.sub(r'^(Title|Titel|Titre|Name|Name:):\s*', '', generated_name, flags=re.IGNORECASE)
-        generated_name = re.sub(r'^["\']|["\']$', '', generated_name)  # Remove surrounding quotes
-        generated_name = re.sub(r'^#+\s*', '', generated_name)  # Remove markdown headers
-        generated_name = re.sub(r'^```.*?\n', '', generated_name, flags=re.DOTALL)  # Remove code blocks start
-        generated_name = re.sub(r'\n.*?```$', '', generated_name, flags=re.DOTALL)  # Remove code blocks end
-        
-        # Take only the first line (in case AI added explanations)
+        # Extract first line and clean up
         generated_name = generated_name.split('\n')[0].strip()
+        generated_name = re.sub(r'^(Title|Titel|Titre|Name|Name:):\s*', '', generated_name, flags=re.IGNORECASE)
+        generated_name = re.sub(r'^["\']|["\']$', '', generated_name)
+        generated_name = re.sub(r'[?!.]+$', '', generated_name)  # Remove trailing punctuation
         
-        # Remove ALL question marks, exclamation marks, and trailing periods
-        generated_name = re.sub(r'[?!]+', '', generated_name)  # Remove all ? and !
-        generated_name = re.sub(r'\.+$', '', generated_name)  # Remove trailing periods
-        
-        generated_name = generated_name.strip()
-        
-        # Ensure proper title case (capitalize first letter of each word, but handle acronyms)
+        # Apply title case
         if generated_name:
-            # Split into words and capitalize properly
             words = generated_name.split()
             capitalized_words = []
             for word in words:
-                # Keep acronyms (all caps) as-is, otherwise capitalize first letter
                 if word.isupper() and len(word) > 1:
-                    capitalized_words.append(word)
+                    capitalized_words.append(word)  # Keep acronyms
                 else:
-                    # Capitalize first letter, lowercase the rest
                     capitalized_words.append(word.capitalize())
-            generated_name = " ".join(capitalized_words)
+            generated_name = " ".join(capitalized_words).strip()
         
-        # Validate: should be a proper title, not just copied words
-        # Check if it's too similar to the original (just first words)
-        prompt_words = set(userPrompt.lower().split()[:6])
-        name_words = set(generated_name.lower().split())
-        similarity = len(prompt_words.intersection(name_words)) / max(len(prompt_words), 1)
-        
-        # If too similar (more than 80% same words), it's probably just copied
-        if similarity > 0.8 and len(generated_name.split()) <= len(userPrompt.split()[:5]):
-            logger.warning(f"Generated name too similar to input, regenerating: {generated_name}")
-            # Try once more with a more explicit prompt
-            retry_prompt = f"""CRITICAL: Create a professional title in THE SAME LANGUAGE as the user's question.
-
-Question: {truncated_prompt}
-
-The title MUST be in the exact same language as the question above.
-- If the question is in German, respond in German
-- If the question is in French, respond in French  
-- If the question is in English, respond in English
-
-Create a professional title (max 60 characters, no punctuation) that summarizes the topic.
-
-Title (in the same language as the question):"""
-            # Ensure AI services are initialized (should already be, but be safe)
-            await services.ai.ensureAiObjectsInitialized()
-            
-            retryRequest = AiCallRequest(
-                prompt=retry_prompt,
-                options=AiCallOptions(
-                    resultFormat="txt",
-                    operationType=OperationTypeEnum.DATA_GENERATE,
-                    processingMode=ProcessingModeEnum.DETAILED,
-                    temperature=0.8
-                )
-            )
-            retryResponse = await services.ai.callAi(retryRequest)
-            generated_name = retryResponse.content.strip()
-            generated_name = re.sub(r'^(Title|Titel|Titre|Name|Name:):\s*', '', generated_name, flags=re.IGNORECASE)
-            generated_name = re.sub(r'^["\']|["\']$', '', generated_name)
-            generated_name = generated_name.split('\n')[0].strip()
-            generated_name = re.sub(r'[?!]+', '', generated_name)  # Remove all ? and !
-            generated_name = re.sub(r'\.+$', '', generated_name)  # Remove trailing periods
-            # Apply title case
-            if generated_name:
-                words = generated_name.split()
-                capitalized_words = []
-                for word in words:
-                    if word.isupper() and len(word) > 1:
-                        capitalized_words.append(word)
-                    else:
-                        capitalized_words.append(word.capitalize())
-                generated_name = " ".join(capitalized_words).strip()
-        
-        # Final validation and length check
+        # Validate and truncate if needed
         if not generated_name or len(generated_name) < 3:
-            logger.error(f"Generated name too short or empty: '{generated_name}'")
-            # Use default title based on language
             if userLanguage == "de":
                 generated_name = "Chatbot Konversation"
             elif userLanguage == "fr":
@@ -343,26 +124,16 @@ Title (in the same language as the question):"""
             else:
                 generated_name = "Chatbot Conversation"
         
-        # Final cleanup: ensure no question marks or trailing punctuation
-        generated_name = re.sub(r'[?!]+', '', generated_name)
-        generated_name = re.sub(r'\.+$', '', generated_name).strip()
-        
-        # Final length check and truncation
         if len(generated_name) > 60:
-            # Try to truncate at word boundary
             truncated = generated_name[:57]
             last_space = truncated.rfind(' ')
-            if last_space > 30:  # Only truncate at word boundary if reasonable
-                generated_name = truncated[:last_space] + "..."
-            else:
-                generated_name = truncated + "..."
+            generated_name = truncated[:last_space] + "..." if last_space > 30 else truncated + "..."
         
-        logger.info(f"Generated conversation name: '{generated_name}' from prompt: '{userPrompt[:50]}...'")
+        logger.info(f"Generated conversation name: '{generated_name}'")
         return generated_name
         
     except Exception as e:
         logger.error(f"Error generating conversation name: {e}", exc_info=True)
-        # Use default title based on language
         if userLanguage == "de":
             return "Chatbot Konversation"
         elif userLanguage == "fr":
@@ -456,6 +227,39 @@ async def chatProcess(
         # Reload workflow to get current message count
         workflow = interfaceDbChat.getWorkflow(workflow.id)
         
+        # Process uploaded files and create ChatDocuments
+        user_documents = []
+        if userInput.listFileId and len(userInput.listFileId) > 0:
+            logger.info(f"Processing {len(userInput.listFileId)} uploaded file(s) for user message")
+            for fileId in userInput.listFileId:
+                try:
+                    # Get file info from chat service
+                    fileInfo = services.chat.getFileInfo(fileId)
+                    if not fileInfo:
+                        logger.warning(f"No file info found for file ID {fileId}")
+                        continue
+                    
+                    originalFileName = fileInfo.get("fileName", "unknown")
+                    originalMimeType = fileInfo.get("mimeType", "application/octet-stream")
+                    fileSizeToUse = fileInfo.get("size", 0)
+                    
+                    # Create ChatDocument for the file
+                    document = ChatDocument(
+                        id=str(uuid.uuid4()),
+                        messageId="",  # Will be set when message is created
+                        fileId=fileId,
+                        fileName=originalFileName,
+                        fileSize=fileSizeToUse,
+                        mimeType=originalMimeType,
+                        roundNumber=workflow.currentRound,
+                        taskNumber=0,
+                        actionNumber=0
+                    )
+                    user_documents.append(document)
+                    logger.info(f"Created ChatDocument for file {fileId} -> {originalFileName}")
+                except Exception as e:
+                    logger.error(f"Error processing file ID {fileId}: {e}", exc_info=True)
+        
         # Store user message
         userMessageData = {
             "id": f"msg_{uuid.uuid4()}",
@@ -469,8 +273,18 @@ async def chatProcess(
             "taskNumber": 0,
             "actionNumber": 0
         }
+        
+        # Add documents to message if any
+        if user_documents:
+            # Update messageId in all documents
+            for doc in user_documents:
+                doc.messageId = userMessageData["id"]
+            userMessageData["documents"] = [doc.dict() for doc in user_documents]
+            userMessageData["documentsLabel"] = "Uploaded Files"
+            logger.info(f"Attaching {len(user_documents)} document(s) to user message")
+        
         userMessage = interfaceDbChat.createMessage(userMessageData)
-        logger.info(f"Stored user message: {userMessage.id}")
+        logger.info(f"Stored user message: {userMessage.id} with {len(user_documents)} document(s)")
         
         # Emit message event for streaming (exact chatData format)
         event_manager = get_event_manager()
@@ -530,6 +344,212 @@ async def _check_workflow_status(interfaceDbChat, workflowId: str, event_manager
     return False
 
 
+async def _convert_file_ids_to_document_references(
+    services,
+    file_ids: List[str]
+) -> DocumentReferenceList:
+    """
+    Convert file IDs to DocumentReferenceList for use with ai.process.
+    
+    Args:
+        services: Services instance
+        file_ids: List of file IDs to convert
+        
+    Returns:
+        DocumentReferenceList with docItem references
+    """
+    references = []
+    
+    # Get workflow to search for ChatDocuments
+    workflow = services.workflow
+    if not workflow:
+        logger.error("Cannot convert file IDs to document references: workflow not set in services")
+        return DocumentReferenceList(references=[])
+    
+    for file_id in file_ids:
+        try:
+            # Get file info to verify it exists
+            file_info = services.chat.getFileInfo(file_id)
+            if not file_info:
+                logger.warning(f"File {file_id} not found, skipping")
+                continue
+            
+            # Find ChatDocument that has this fileId
+            document_id = None
+            if workflow.messages:
+                for message in workflow.messages:
+                    if hasattr(message, 'documents') and message.documents:
+                        for doc in message.documents:
+                            if getattr(doc, 'fileId', None) == file_id:
+                                document_id = getattr(doc, 'id', None)
+                                break
+                    if document_id:
+                        break
+            
+            # Search database if not found in messages
+            if not document_id:
+                try:
+                    from modules.datamodels.datamodelChat import ChatDocument
+                    from modules.shared.databaseUtils import getRecordsetWithRBAC
+                    documents = getRecordsetWithRBAC(
+                        services.interfaceDbChat.db,
+                        ChatDocument,
+                        services.currentUser,
+                        recordFilter={"fileId": file_id}
+                    )
+                    if documents:
+                        workflow_message_ids = {msg.id for msg in workflow.messages} if workflow.messages else set()
+                        for doc in documents:
+                            if doc.get("messageId") in workflow_message_ids:
+                                document_id = doc.get("id")
+                                break
+                except Exception:
+                    pass  # Fallback to fileId
+            
+            # Use ChatDocument ID if found, otherwise use fileId as fallback
+            ref = DocumentItemReference(documentId=document_id if document_id else file_id)
+            references.append(ref)
+        except Exception as e:
+            logger.error(f"Error converting fileId {file_id}: {e}", exc_info=True)
+    
+    logger.info(f"Converted {len(references)} file IDs to document references")
+    return DocumentReferenceList(references=references)
+
+
+def _format_query_results_as_lookup(query_data: Dict[str, List[Dict]]) -> str:
+    """
+    Format database query results as JSON lookup table for Excel matching.
+    Converts query result data into structured JSON format: {Artikelnummer: {columns...}}
+    
+    Args:
+        query_data: Dict with query_key -> list of row dicts (from connector with return_json=True)
+        
+    Returns:
+        JSON string formatted as lookup table
+    """
+    lookup_table = {}
+    
+    for query_key, rows in query_data.items():
+        if query_key == "error" or not rows:
+            logger.warning(f"Skipping query key '{query_key}' - no rows or error")
+            continue
+        
+        logger.info(f"Processing {len(rows)} rows from query '{query_key}'")
+        
+        for row in rows:
+            if not isinstance(row, dict):
+                logger.warning(f"Skipping non-dict row: {type(row)}")
+                continue
+            
+            # Find Artikelnummer field (case-insensitive)
+            artikelnummer = None
+            for key in row.keys():
+                if key.lower() in ['artikelnummer', 'artikel_nummer', 'art_nr', 'part_number']:
+                    artikelnummer = str(row[key])
+                    break
+            
+            if artikelnummer:
+                lookup_table[artikelnummer] = row
+            else:
+                logger.warning(f"No Artikelnummer found in row with keys: {list(row.keys())}")
+    
+    logger.info(f"Generated lookup table with {len(lookup_table)} entries")
+    if lookup_table:
+        sample_keys = list(lookup_table.keys())[:3]
+        logger.info(f"Sample Artikelnummern: {sample_keys}")
+        if sample_keys:
+            sample_entry = lookup_table[sample_keys[0]]
+            logger.info(f"Sample entry keys: {list(sample_entry.keys())}")
+    
+    return json.dumps(lookup_table, ensure_ascii=False, indent=2)
+
+
+async def _create_chat_document_from_action_document(
+    services,
+    action_document,
+    message_id: str,
+    workflow_id: str,
+    round_number: int
+) -> ChatDocument:
+    """
+    Create a ChatDocument from an ActionDocument by storing the file data.
+    
+    Args:
+        services: Services instance
+        action_document: ActionDocument from ai.process result
+        message_id: ID of the message to attach to
+        workflow_id: Workflow ID
+        round_number: Round number
+        
+    Returns:
+        ChatDocument instance
+    """
+    try:
+        # Get file data (could be bytes or string)
+        document_data = action_document.documentData
+        
+        # Convert to bytes if needed
+        if isinstance(document_data, str):
+            # Check if it's base64 encoded
+            try:
+                # Try to decode as base64 first
+                file_bytes = base64.b64decode(document_data)
+            except Exception:
+                # Not base64, encode as UTF-8
+                file_bytes = document_data.encode('utf-8')
+        elif isinstance(document_data, bytes):
+            file_bytes = document_data
+        else:
+            # Try to convert to bytes
+            try:
+                file_bytes = bytes(document_data)
+            except Exception:
+                # Last resort: convert to string then encode
+                file_bytes = str(document_data).encode('utf-8')
+        
+        # Get MIME type (default to Excel)
+        mime_type = action_document.mimeType or "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
+        
+        # Get file name
+        file_name = action_document.documentName or "data_export.xlsx"
+        # Ensure it has .xlsx extension
+        if not file_name.lower().endswith('.xlsx'):
+            # Remove any existing extension and add .xlsx
+            file_name = file_name.rsplit('.', 1)[0] + '.xlsx'
+        
+        # Store file using component interface
+        file_item = services.interfaceDbComponent.createFile(
+            name=file_name,
+            mimeType=mime_type,
+            content=file_bytes
+        )
+        
+        # Store file data
+        success = services.interfaceDbComponent.createFileData(file_item.id, file_bytes)
+        if not success:
+            logger.warning(f"Failed to store file data for {file_item.id}, but continuing...")
+        
+        # Create ChatDocument
+        chat_document = ChatDocument(
+            id=str(uuid.uuid4()),
+            messageId=message_id,
+            fileId=file_item.id,
+            fileName=file_name,
+            fileSize=len(file_bytes),
+            mimeType=mime_type,
+            roundNumber=round_number,
+            taskNumber=0,
+            actionNumber=0
+        )
+        
+        logger.info(f"Created ChatDocument {chat_document.id} from ActionDocument {file_name} (size: {len(file_bytes)} bytes)")
+        return chat_document
+        
+    except Exception as e:
+        logger.error(f"Error creating ChatDocument from ActionDocument: {e}", exc_info=True)
+        raise
+
+
 async def _processChatbotMessage(
     services,
     workflowId: str,
@@ -538,7 +558,7 @@ async def _processChatbotMessage(
 ):
     """
     Process chatbot message in background.
-    Executes the actual chatbot logic.
+    Simplified 4-step flow: Analysis → Query → Excel → Answer
     """
     event_manager = get_event_manager()
     
@@ -549,44 +569,16 @@ async def _processChatbotMessage(
         workflow = interfaceDbChat.getWorkflow(workflowId)
         if not workflow:
             logger.error(f"Workflow {workflowId} not found during processing")
-            await event_manager.emit_event(
-                workflowId,
-                "error",
-                f"Workflow {workflowId} nicht gefunden",
-                "error"
-            )
+            await event_manager.emit_event(workflowId, "error", f"Workflow {workflowId} nicht gefunden", "error")
             return
         
-        # Check if workflow was stopped
         if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
             return
         
-        # Helper function to process streaming messages from AI responses and create logs
-        def process_streaming_messages(ai_response_data: Dict[str, Any], progress: Optional[float] = None):
-            """Process streaming messages from AI response and create logs."""
-            if not ai_response_data:
-                return
-            
-            streaming_messages = ai_response_data.get("streamingMessages", [])
-            if isinstance(streaming_messages, list):
-                workflow = interfaceDbChat.getWorkflow(workflowId)
-                if workflow:
-                    for msg in streaming_messages:
-                        if isinstance(msg, str) and msg.strip():
-                            try:
-                                services.chat.storeLog(workflow, {
-                                    "message": msg.strip(),
-                                    "type": "info",
-                                    "status": "running",
-                                    "progress": progress if progress is not None else 0.5
-                                })
-                            except Exception as e:
-                                logger.warning(f"Error creating log from streaming message: {e}")
-        
         # Build conversation context from history
         context = ""
         if workflow.messages:
-            recent_messages = workflow.messages[-5:]  # Last 5 messages
+            recent_messages = workflow.messages[-5:]
             context = "\n\nPrevious conversation:\n"
             for msg in recent_messages:
                 if msg.role == "user":
